﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RikaiChanClone
{
    internal static class Extensions
    {
        public static IEnumerable<int> Until(this int startValue, int limit)
        {
            if (startValue > limit)
            {
                for (int i = startValue; i > limit; i--)
                {
                    yield return i;
                }
            }
            else
            {
                for (int i = startValue; i < limit; i++)
                {
                    yield return i;
                }
            }
        }

        public static void ForEach<T>(this IEnumerable<T> sequence, Action<T> action)
        {
            foreach (var element in sequence)
            {
                action(element);
            }
        }
        public static void ForEach<T>(this IEnumerable<T> sequence, Action<T,int> action)
        {
            int i = 0;
            foreach (var element in sequence)
            {
                action(element,i);
                i++;
            }
        }
    }
}
