﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace RikaiChanClone
{
    class RikaiChanTextBox : TextBox
    {
        static FloatWindow floatWindow = null;

        public RikaiChanTextBox()
            : base()
        {
            var parentForm = FindForm();
            this.MouseMove += RikaiChanTextBox_MouseMove;
            this.MouseLeave += RikaiChanTextBox_MouseLeave;
        }

        protected override void Dispose(bool disposing)
        {
            if (floatWindow != null)
            {
                if (!floatWindow.IsDisposed)
                {
                    floatWindow.Close();
                    floatWindow.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        protected override void WndProc(ref Message m)
        {
            const int WM_MBUTTONDOWN = 0x207;

            if (m.Msg != WM_MBUTTONDOWN)
            {
                base.WndProc(ref m);
            }
            else
            {
                DefWndProc(ref m);
            }
        }

        private void RikaiChanTextBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (floatWindow == null) floatWindow = new FloatWindow();

            var textBox = (TextBox)sender;

            string text = textBox.Text;
            int index = textBox.GetCharIndexFromPosition(e.Location);
            if (index >= 0 && index < text.Length)
            {
                int maxRemaining = text.Length - index;
                int max = Math.Min(maxRemaining, 16);

                string sub = text.Substring(index, max);
                var lookupText = JEDictionary.LookupAll(sub);

                if (lookupText == "")
                {
                    floatWindow.Hide();
                }
                else
                {

                    floatWindow.LabelText = lookupText;
                    var screenLocation = textBox.PointToScreen(e.Location);
                    screenLocation.Offset(2, 32);
                    floatWindow.Location = screenLocation;
                    NativeMethods.ShowInactiveTopmost(floatWindow);
                }
            }
        }

        private void RikaiChanTextBox_MouseLeave(object sender, EventArgs e)
        {
            if (floatWindow == null) floatWindow = new FloatWindow();
            floatWindow.Hide();
        }
    }

}
